# generated by datamodel-codegen:
#   filename:  create_data_room.json

from __future__ import annotations

from typing import Optional, Sequence

from typing_extensions import Literal, NotRequired, TypedDict

FormatType = Literal[
    'STRING',
    'INTEGER',
    'FLOAT',
    'EMAIL',
    'DATE_ISO8601',
    'PHONE_NUMBER_E164',
    'HASH_SHA256_HEX',
]


HashingAlgorithm = Literal['SHA256_HEX']


Permission = Literal[
    'VIEW_OVERLAP',
    'VIEW_INSIGHTS',
    'PROVIDE_SEED_AUDIENCE',
    'PROVIDE_BASE_AUDIENCE',
    'CREATE_CUSTOM_AUDIENCE',
    'EXPORT_AUDIENCE',
    'MODEL_QUALITY',
]


class ParticipantGroup(TypedDict):
    emails: Sequence[str]
    organizationId: NotRequired[Optional[str]]
    permissions: Sequence[Permission]
    role: str


class CreateDataRoom1(TypedDict):
    kind: Literal['media']
    audiencesPolicyId: NotRequired[Optional[str]]
    demographicsPolicyId: NotRequired[Optional[str]]
    embeddingsPolicyId: NotRequired[Optional[str]]
    enableDebugMode: bool
    enableInsights: bool
    enableLookalikeAudiences: bool
    enableRemarketing: bool
    enableRuleBasedAudiences: bool
    hashMatchingIdWith: NotRequired[Optional[HashingAlgorithm]]
    hideAbsoluteValuesFromInsights: bool
    matchingIdFormat: FormatType
    matchingIdsPolicyId: NotRequired[Optional[str]]
    name: str
    participantGroups: Sequence[ParticipantGroup]
    segmentsPolicyId: NotRequired[Optional[str]]
    version: Literal['v0']


CreateDataRoom = CreateDataRoom1
